/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of XS.xs. Do not edit this file, edit XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "XS.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

// C99 required

//#define BENCHMARK

enum {
  // ASN_TAG
  ASN_BOOLEAN           = 0x01,
  ASN_INTEGER32         = 0x02,
  ASN_BIT_STRING        = 0x03,
  ASN_OCTET_STRING      = 0x04,
  ASN_NULL              = 0x05,
  ASN_OBJECT_IDENTIFIER = 0x06,
  ASN_SEQUENCE          = 0x10,

  ASN_TAG_BER           = 0x1f,
  ASN_TAG_MASK          = 0x1f,

  // primitive/constructed
  ASN_CONSTRUCTED       = 0x20,

  // ASN_CLASS
  ASN_UNIVERSAL         = 0x00,
  ASN_APPLICATION       = 0x40,
  ASN_CONTEXT           = 0x80,
  ASN_PRIVATE           = 0xc0,

  ASN_CLASS_MASK        = 0xc0,
  ASN_CLASS_SHIFT       = 6,

  // ASN_APPLICATION
  ASN_IPADDRESS         = 0x00,
  ASN_COUNTER32         = 0x01,
  ASN_UNSIGNED32        = 0x02,
  ASN_TIMETICKS         = 0x03,
  ASN_OPAQUE            = 0x04,
  ASN_COUNTER64         = 0x06,
};

#define MAX_OID_STRLEN 4096

#define HAVE_VERSIONSORT defined (_GNU_SOURCE) && __GLIBC__ >= 2 && __GLIBC_MINOR__ >= 1

static SV *cur_bufobj;
static SV *msg, *bufsv;
static int errflag, leading_dot;
static U8 *buf, *cur;
static STRLEN len, rem;

typedef SV *BUFOBJ;

/////////////////////////////////////////////////////////////////////////////

#if 0
        if (msg)
          croak ("recursive invocation of Net::SNMP::XS parser is not supported");


void
clr_msg ()
	CODE:
        SvREFCNT_dec (msg); msg = 0;
        buf = cur = (U8 *)"";
        len = rem = 0;
#endif

static void
clear_bufobj (void)
{
  // serialise our state back
  if (msg && SvROK (msg))
    {
      SV *idx_sv = *hv_fetch ((HV *)cur_bufobj, "_index" , sizeof ("_index" ) - 1, 1);
      sv_setiv (idx_sv, cur - buf);
    }

  SvREFCNT_dec (msg);
  msg        = 0;
  cur_bufobj = 0;
}

static void
switch_bufobj (BUFOBJ neu)
{
  clear_bufobj ();

  msg = newSVsv (neu);
  cur_bufobj = SvRV (msg);
  sv_rvweaken (msg);

  errflag     = 0;
  leading_dot = -1;

  IV index = SvIV (*hv_fetch ((HV *)cur_bufobj, "_index" , sizeof ("_index" ) - 1, 1));
  bufsv    =       *hv_fetch ((HV *)cur_bufobj, "_buffer", sizeof ("_buffer") - 1, 1);

  buf = SvPVbyte (bufsv, len);
  cur = buf + index;
  rem = len - index;
}

/////////////////////////////////////////////////////////////////////////////

static SV *
x_get_cv (SV *cb_sv)
{
  HV *st;
  GV *gvp;
  CV *cv = sv_2cv (cb_sv, &st, &gvp, 0);

  if (!cv)
    croak ("CODE reference expected");

  return (SV *)cv;
}

static void
error (const char *errmsg)
{
  errflag = 1;

  if (!msg)
    croak ("Net::SNMP::XS fatal error, parser called without parsing context");

  dSP;
  PUSHMARK (SP);
  EXTEND (SP, 2);
  PUSHs (msg);
  PUSHs (sv_2mortal (newSVpv (errmsg, 0)));
  PUTBACK;
  call_method ("_error", G_VOID | G_DISCARD);
}

static int
need (int count)
{
  if (count < 0 || (int)rem < count)
    {
      error ("Unexpected end of message buffer");
      return 0;
    }

  return 1;
}

static U8 *
getn (int count, const U8 *errres)
{
  if (!need (count))
    return (U8 *)errres;

  U8 *res = cur;

  cur += count;
  rem -= count;

  return res;
}

static U8
get8 (void)
{
  if (rem <= 0)
    {
      error ("Unexpected end of message buffer");
      return 0;
    }

  rem--;
  return *cur++;
}

static U32
getb (void)
{
  U32 res = 0;

  for (;;)
    {
      U8 c = get8 ();
      res = (res << 7) | (c & 0x7f);

      if (!(c & 0x80))
        return res;
    }
}

#ifdef BENCHMARK
static double t1;

static double
tstamp (void)
{
  struct timeval tv;
  gettimeofday (&tv, 0);
  return tv.tv_sec + tv.tv_usec * 0.000001;
}
#endif

static U32
process_length (void)
{
  U32 res = get8 ();

  if (res & 0x80)
    {
      int cnt = res & 0x7f;
      res = 0;

      switch (cnt)
        {
          case 0:
            error ("Indefinite ASN.1 lengths not supported");
            return 0;

          default:
            error ("ASN.1 length too long");
            return 0;

          case 4: res = (res << 8) | get8 ();
          case 3: res = (res << 8) | get8 ();
          case 2: res = (res << 8) | get8 ();
          case 1: res = (res << 8) | get8 ();
        }
    }

  return res;
}

static U32
process_integer32 (void)
{
  U32 length = process_length ();

  if (length <= 0)
    {
      error ("INTEGER32 length equal to zero");
      return 0;
    }

  U8 *data = getn (length, 0);

  if (!data)
    return 0;

  if (length > 5 || (length > 4 && data [0]))
    {
      error ("INTEGER32 length too long");
      return 0;
    }

  U32 res = data [0] & 0x80 ? 0xffffffff : 0;

  while (length--)
    res = (res << 8) | *data++;

  return res;
}

static SV *
process_integer32_sv (void)
{
  return newSViv ((I32)process_integer32 ());
}

static SV *
process_unsigned32_sv (void)
{
  return newSVuv ((U32)process_integer32 ());
}

#if IVSIZE >= 8

static U64TYPE
process_integer64 (void)
{
  U32 length = process_length ();

  if (length <= 0)
    {
      error ("INTEGER64 length equal to zero");
      return 0;
    }

  U8 *data = getn (length, 0);

  if (!data)
    return 0;

  if (length > 8 + !data [0])
    {
      error ("INTEGER64 length too long");
      return 0;
    }

  U64TYPE res = data [0] & 0x80 ? -1 : 0;

  while (length--)
    res = (res << 8) | *data++;

  return res;
}

static SV *
process_integer64_sv (void)
{
  return newSViv ((I64TYPE)process_integer64 ());
}

static SV *
process_unsigned64_sv (void)
{
  return newSVuv ((U64TYPE)process_integer64 ());
}

#endif

static SV *
process_octet_string_sv (void)
{
  U32 length = process_length ();

  U8 *data = getn (length, 0);
  if (!data)
    {
      error ("OCTET STRING too long");
      return &PL_sv_undef;
    }

  return newSVpvn (data, length);
}

static char *
write_uv (char *buf, U32 u)
{
  // the one-digit case is absolutely predominant, so this pays off (hopefully)
  if (u < 10)
    *buf++ = u + '0';
  else
    {
      // this *could* be done much faster using branchless fixed-point arithmetics
      char *beg = buf;

      do
        {
          *buf++ = u % 10 + '0';
          u /= 10;
        }
      while (u);

      // reverse digits
      char *ptr = buf;
      while (--ptr > beg)
        {
          char c = *ptr;
          *ptr = *beg;
          *beg = c;
          ++beg;
        }
    }

  return buf;
}

static SV *
process_object_identifier_sv (void)
{
  U32 length = process_length ();

  if (length <= 0)
    {
      error ("OBJECT IDENTIFIER length equal to zero");
      return &PL_sv_undef;
    }

  U8 *end = cur + length;
  U32 w = getb ();

  static char oid[MAX_OID_STRLEN]; // must be static
  char *app = oid;

  if (leading_dot < 0)
    leading_dot = SvTRUE (*hv_fetch ((HV *)SvRV (msg), "_leading_dot", sizeof ("_leading_dot") - 1, 1));

  *app = '.'; app += ! ! leading_dot;

  {
    UV w1, w2;
    
    if (w < 2 * 40)
      (w1 = w / 40), (w2 = w % 40);
    else
      (w1 =      2), (w2 = w - 2 * 40);
    
    app = write_uv (app, w1);
    *app++ = '.';
    app = write_uv (app, w2);
  }

  // we assume an oid component is never > 64 bytes
  while (cur < end && oid + sizeof (oid) - app > 64)
    {
      w = getb ();
      *app++ = '.';
      app = write_uv (app, w);
    }

  return newSVpvn (oid, app - oid);
}

static AV *av_type;

static SV *
process_sv (int *found)
{
  int type = get8 ();

  *found = type;

  SV *res;

  switch (type)
    {
      case ASN_OBJECT_IDENTIFIER:
        res = process_object_identifier_sv ();
        break;

      case ASN_INTEGER32:
        res = process_integer32_sv ();
        break;

      case ASN_APPLICATION | ASN_UNSIGNED32:
      case ASN_APPLICATION | ASN_COUNTER32:
      case ASN_APPLICATION | ASN_TIMETICKS:
        res = process_unsigned32_sv ();
        break;

      case ASN_SEQUENCE | ASN_CONSTRUCTED:
        res = newSVuv (process_length ());
        break;

      case ASN_OCTET_STRING:
      case ASN_APPLICATION | ASN_OPAQUE:
        res = process_octet_string_sv ();
        break;

      default:
        {
          if (type > AvFILLp (av_type)
              || AvARRAY (av_type)[type] == 0
              || AvARRAY (av_type)[type] == &PL_sv_undef)
            {
              error ("Unknown ASN.1 type");
              return &PL_sv_undef;
            }

          dSP;
          PUSHMARK (SP);
          EXTEND (SP, 2);
          PUSHs (msg);
          PUSHs (sv_2mortal (newSViv (type)));
          PUTBACK;
          int count = call_sv (AvARRAY (av_type)[type], G_SCALAR);
          SPAGAIN;
          res = count ? SvREFCNT_inc (TOPs) : &PL_sv_undef;
        }
    }

  return errflag ? &PL_sv_undef : res;
}

/////////////////////////////////////////////////////////////////////////////

#if HAVE_VERSIONSORT

static int
oid_lex_cmp (const void *a_, const void *b_)
{
  const char *a = SvPVX (*(SV **)a_);
  const char *b = SvPVX (*(SV **)b_);

  a += *a == '.';
  b += *b == '.';

  return strverscmp (a, b);
}

#endif

#line 503 "XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 647 "XS.c"

XS_EUPXS(XS_Net__SNMP__XS_set_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__XS_set_type)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "type, cv");
    {
	int	type = (int)SvIV(ST(0))
;
	SV *	cv = ST(1)
;
#line 503 "XS.xs"
        cv = x_get_cv (cv);
        assert (SvTYPE (cv) == SVt_PVCV);
        av_store (av_type, type, SvREFCNT_inc_NN (cv));
#line 664 "XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SNMP__Message__buffer_append); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__Message__buffer_append)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, value");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	BUFOBJ	self = ST(0);
	if (SvRV (ST(0)) != cur_bufobj || !SvROK (msg))
          switch_bufobj (ST(0))
;
	SV *	value = ST(1)
;
#line 514 "XS.xs"
{
        STRLEN vlen;
        const char *vstr = SvPVbyte (value, vlen);

        if (ix)
          sv_insert (bufsv, 0, 0, vstr, vlen);
        else
          sv_catpvn (bufsv, vstr, vlen);

        buf = SvPVbyte (bufsv, len);
        cur = buf;
        rem = len;

	SV *len_sv = *hv_fetch ((HV *)cur_bufobj, "_length", sizeof ("_length") - 1, 1);
        sv_setiv (len_sv, len);

        // some callers test for defined'ness of the returnvalue. *sigh*
        XPUSHs (&PL_sv_yes);
}
#line 706 "XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SNMP__Message__buffer_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__Message__buffer_get)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, count= -1");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	BUFOBJ	self = ST(0);
	if (SvRV (ST(0)) != cur_bufobj || !SvROK (msg))
          switch_bufobj (ST(0))
;
	int	count;

	if (items < 2)
	    count = -1;
	else {
	    count = (int)SvIV(ST(1))
;
	}
#line 537 "XS.xs"
{
	// grrr.
	if (count < 0)
          {
            hv_delete ((HV *)SvRV (self), "_index" , 6, G_DISCARD);
            hv_delete ((HV *)SvRV (self), "_length", 7, G_DISCARD);
            XPUSHs (sv_2mortal (newSVsv (bufsv)));
            sv_setpvn (bufsv, "", 0);

            buf = "";
            cur = buf;
            rem = 0;

            XSRETURN (1);
          }

        char *data = getn (count, 0);

        if (data)
          XPUSHs (sv_2mortal (newSVpvn (data, count)));
}
#line 756 "XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SNMP__Message_index); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__Message_index)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, ndx= -1");
    {
	U32	RETVAL;
	dXSTARG;
	BUFOBJ	self = ST(0);
	if (SvRV (ST(0)) != cur_bufobj || !SvROK (msg))
          switch_bufobj (ST(0))
;
	int	ndx;

	if (items < 2)
	    ndx = -1;
	else {
	    ndx = (int)SvIV(ST(1))
;
	}
#line 562 "XS.xs"
{
        if (ndx >= 0 && ndx < len)
          {
            cur = buf + ndx;
            rem = len - ndx;
          }

        RETVAL = cur - buf;
}
#line 794 "XS.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SNMP__Message__process_length); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__Message__process_length)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	U32	RETVAL;
	dXSTARG;
	BUFOBJ	self = ST(0);
	if (SvRV (ST(0)) != cur_bufobj || !SvROK (msg))
          switch_bufobj (ST(0))
;
#line 578 "XS.xs"
        RETVAL = process_length ();
#line 817 "XS.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SNMP__Message__process_integer32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__Message__process_integer32)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	RETVAL;
	BUFOBJ	self = ST(0);
	if (SvRV (ST(0)) != cur_bufobj || !SvROK (msg))
          switch_bufobj (ST(0))
;
#line 584 "XS.xs"
        RETVAL = process_integer32_sv ();
#line 838 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SNMP__Message__process_counter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__Message__process_counter)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	RETVAL;
	BUFOBJ	self = ST(0);
	if (SvRV (ST(0)) != cur_bufobj || !SvROK (msg))
          switch_bufobj (ST(0))
;
#line 593 "XS.xs"
        RETVAL = process_unsigned32_sv ();
#line 861 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#if IVSIZE >= 8
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Net__SNMP__Message__process_counter64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__Message__process_counter64)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	RETVAL;
	BUFOBJ	self = ST(0);
	if (SvRV (ST(0)) != cur_bufobj || !SvROK (msg))
          switch_bufobj (ST(0))
;
#line 601 "XS.xs"
        RETVAL = process_unsigned64_sv ();
#line 886 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Net__SNMP__Message__process_object_identifier); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__Message__process_object_identifier)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	RETVAL;
	BUFOBJ	self = ST(0);
	if (SvRV (ST(0)) != cur_bufobj || !SvROK (msg))
          switch_bufobj (ST(0))
;
#line 609 "XS.xs"
        RETVAL = process_object_identifier_sv ();
#line 909 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SNMP__Message__process_octet_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__Message__process_octet_string)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	RETVAL;
	BUFOBJ	self = ST(0);
	if (SvRV (ST(0)) != cur_bufobj || !SvROK (msg))
          switch_bufobj (ST(0))
;
#line 617 "XS.xs"
        RETVAL = process_octet_string_sv ();
#line 932 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SNMP__Message__process_ipaddress); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__Message__process_ipaddress)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	RETVAL;
	BUFOBJ	self = ST(0);
	if (SvRV (ST(0)) != cur_bufobj || !SvROK (msg))
          switch_bufobj (ST(0))
;
#line 623 "XS.xs"
{
	U32 length = process_length ();
        if (length != 4)
          {
            error ("IP ADDRESS length not four");
            XSRETURN_UNDEF;
          }

        U8 *data = getn (4, "\x00\x00\x00\x00");
        RETVAL = newSVpvf ("%d.%d.%d.%d", data [0], data [1], data [2], data [3]);
}
#line 964 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SNMP__Message_process); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__Message_process)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, expected= &PL_sv_undef, found= 0");
    {
	SV *	RETVAL;
	BUFOBJ	self = ST(0);
	if (SvRV (ST(0)) != cur_bufobj || !SvROK (msg))
          switch_bufobj (ST(0))
;
	SV *	expected;
	SV *	found;

	if (items < 2)
	    expected = &PL_sv_undef;
	else {
	    expected = ST(1)
;
	}

	if (items < 3)
	    found = 0;
	else {
	    found = ST(2)
;
	}
#line 639 "XS.xs"
{
	int type;

        RETVAL = process_sv (&type);

        if (found)
          sv_setiv (found, type);

        if (SvOK (expected) && type != SvIV (expected))
          error ("Expected a different type than found");
}
#line 1012 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SNMP__PDU__process_var_bind_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__PDU__process_var_bind_list)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	BUFOBJ	self = ST(0);
	if (SvRV (ST(0)) != cur_bufobj || !SvROK (msg))
          switch_bufobj (ST(0))
;
#line 657 "XS.xs"
{
        if (get8 () != (ASN_SEQUENCE | ASN_CONSTRUCTED))
          error ("SEQUENCE expected at beginning of VarBindList");

        int seqlen = process_length ();
        U8 *end = cur + seqlen;

        HV *list  = newHV ();
        AV *names = newAV ();
        HV *types = newHV ();

        hv_store ((HV *)cur_bufobj, "_var_bind_list" , sizeof ("_var_bind_list" ) - 1, newRV_noinc ((SV *)list ), 0);
        hv_store ((HV *)cur_bufobj, "_var_bind_names", sizeof ("_var_bind_names") - 1, newRV_noinc ((SV *)names), 0);
        hv_store ((HV *)cur_bufobj, "_var_bind_types", sizeof ("_var_bind_types") - 1, newRV_noinc ((SV *)types), 0);

        while (cur < end && !errflag)
          {
            // SEQUENCE ObjectName ObjectSyntax
            if (get8 () != (ASN_SEQUENCE | ASN_CONSTRUCTED))
              error ("SEQUENCE expected at beginning of VarBind");
            process_length ();

            if (get8 () != ASN_OBJECT_IDENTIFIER)
              error ("OBJECT IDENTIFIER expected at beginning of VarBind");
            int type, oidlen;
            SV *oid = process_object_identifier_sv ();
            SV *val = process_sv (&type);

            hv_store_ent (types, oid, newSViv (type), 0);
            hv_store_ent (list , oid, val, 0);
            av_push (names, oid);
          }

        // sigh - great design to do it here
        SV *pdu_type = *hv_fetch ((HV *)cur_bufobj, "_pdu_type" , sizeof ("_pdu_type" ) - 1, 1);

        if (SvIV (pdu_type) == 0xa8) // REPORT
          {
            PUSHMARK (SP);
            XPUSHs (msg);
            PUTBACK;
            call_method ("_report_pdu_error", G_VOID | G_DISCARD);
            SPAGAIN;
            XSRETURN_EMPTY;
          }

        RETVAL = newRV_inc ((SV *)list);
}
#line 1081 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SNMP_oid_base_match); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP_oid_base_match)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "base_, oid_");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	base_ = ST(0)
;
	SV *	oid_ = ST(1)
;
#line 715 "XS.xs"
{
        if (!SvOK (base_) || !SvOK (oid_))
          XSRETURN_NO;

        STRLEN blen, olen;
        char *base = SvPVbyte (base_, blen);
        char *oid  = SvPVbyte (oid_ , olen);

        blen -= *base == '.'; base += *base == '.';
        olen -= *base == '.'; oid  += *oid  == '.';

        if (olen < blen)
          XSRETURN_NO;

        if (memcmp (base, oid, blen))
          XSRETURN_NO;

        if (oid [blen] && oid [blen] != '.')
          XSRETURN_NO;

        XSRETURN_YES;
}
#line 1126 "XS.c"
	PUTBACK;
	return;
    }
}

#if HAVE_VERSIONSORT
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_Net__SNMP_oid_lex_sort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP_oid_lex_sort)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 744 "XS.xs"
{
        // make sure SvPVX is valid
        int i;
        for (i = items; i--; )
          {
            SV *sv = ST (i);

            if (SvTYPE (sv) < SVt_PV || SvTYPE (sv) == SVt_PVAV && SvTYPE (sv) == SVt_PVHV)
              SvPV_force_nolen (sv);
          }

        qsort (&ST (0), items, sizeof (SV *), oid_lex_cmp);

        EXTEND (SP, items);
        // we cheat somewhat by not returning copies here
        for (i = 0; i < items; ++i)
          PUSHs (sv_2mortal (SvREFCNT_inc (ST (i))));
}
#line 1164 "XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SNMP__index_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SNMP__index_cmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	int	RETVAL;
	dXSTARG;
	const char *	a = (const char *)SvPV_nolen(ST(0))
;
	const char *	b = (const char *)SvPV_nolen(ST(1))
;
#line 767 "XS.xs"
        RETVAL = strverscmp (a, b);
#line 1186 "XS.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Net__SNMP__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__SNMP__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Net::SNMP::XS::set_type", XS_Net__SNMP__XS_set_type, file, "$$");
        cv = newXSproto_portable("Net::SNMP::Message::_buffer_append", XS_Net__SNMP__Message__buffer_append, file, "$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Net::SNMP::Message::_buffer_put", XS_Net__SNMP__Message__buffer_append, file, "$$");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("Net::SNMP::Message::_buffer_get", XS_Net__SNMP__Message__buffer_get, file, "$;$");
        (void)newXSproto_portable("Net::SNMP::Message::index", XS_Net__SNMP__Message_index, file, "$;$");
        cv = newXSproto_portable("Net::SNMP::Message::_process_length", XS_Net__SNMP__Message__process_length, file, "$;@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Net::SNMP::Message::_process_sequence", XS_Net__SNMP__Message__process_length, file, "$;@");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("Net::SNMP::Message::_process_integer32", XS_Net__SNMP__Message__process_integer32, file, "$;@");
        cv = newXSproto_portable("Net::SNMP::Message::_process_counter", XS_Net__SNMP__Message__process_counter, file, "$;@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Net::SNMP::Message::_process_gauge", XS_Net__SNMP__Message__process_counter, file, "$;@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Net::SNMP::Message::_process_timeticks", XS_Net__SNMP__Message__process_counter, file, "$;@");
        XSANY.any_i32 = 0;
#if XSubPPtmpAAAA
        (void)newXSproto_portable("Net::SNMP::Message::_process_counter64", XS_Net__SNMP__Message__process_counter64, file, "$;@");
#endif
        (void)newXSproto_portable("Net::SNMP::Message::_process_object_identifier", XS_Net__SNMP__Message__process_object_identifier, file, "$;@");
        cv = newXSproto_portable("Net::SNMP::Message::_process_octet_string", XS_Net__SNMP__Message__process_octet_string, file, "$;@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Net::SNMP::Message::_process_opaque", XS_Net__SNMP__Message__process_octet_string, file, "$;@");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("Net::SNMP::Message::_process_ipaddress", XS_Net__SNMP__Message__process_ipaddress, file, "$;@");
        (void)newXSproto_portable("Net::SNMP::Message::process", XS_Net__SNMP__Message_process, file, "$;$$");
        (void)newXSproto_portable("Net::SNMP::PDU::_process_var_bind_list", XS_Net__SNMP__PDU__process_var_bind_list, file, "$");
        cv = newXSproto_portable("Net::SNMP::oid_base_match", XS_Net__SNMP_oid_base_match, file, "$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Net::SNMP::oid_context_match", XS_Net__SNMP_oid_base_match, file, "$$");
        XSANY.any_i32 = 0;
#if XSubPPtmpAAAB
        (void)newXSproto_portable("Net::SNMP::oid_lex_sort", XS_Net__SNMP_oid_lex_sort, file, "@");
        (void)newXSproto_portable("Net::SNMP::_index_cmp", XS_Net__SNMP__index_cmp, file, "$$");
#endif

    /* Initialisation Section */

#line 498 "XS.xs"
	av_type = newAV ();

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#line 1268 "XS.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

